//
//  MenuButton.swift
//  SlideMenuDemo
//
//  Created by 马超 on 16/5/19.
//  Copyright © 2016年 qq 714080794. All rights reserved.
//

import UIKit

class MenuButton: UIView {

    var buttonColor: UIColor?
    
    private var buttonTitle: String?
    
    init(title: String?) {
        
        super.init(frame: CGRectZero)
        
        buttonTitle = title
        buttonColor = UIColor.orangeColor()
    }
    
    required init?(coder aDecoder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }

    override func drawRect(rect: CGRect) {
        
        // 背景
        let ctx = UIGraphicsGetCurrentContext()
        CGContextAddRect(ctx, rect)
        buttonColor?.set()
        CGContextFillPath(ctx)
        
        
        // 内部的圈
        let path = UIBezierPath(roundedRect: CGRectInset(rect, 1, 1), cornerRadius: rect.size.height / 2)
        buttonColor?.setFill()
        path.fill()
        UIColor.whiteColor().setStroke()
        path.lineWidth = 1
        path.stroke()
        
        let paragraphStyle = NSMutableParagraphStyle()
        paragraphStyle.alignment = NSTextAlignment.Center
        
        let attr = [NSParagraphStyleAttributeName: paragraphStyle ,
                    NSFontAttributeName: UIFont.systemFontOfSize(24.0) ,
                    NSForegroundColorAttributeName: UIColor.whiteColor()]
        if let title = buttonTitle {
            
           let size = (title as NSString).sizeWithAttributes(attr)
            
            let r = CGRectMake(rect.origin.x, rect.origin.y + (rect.size.height - size.height) / 2, rect.size.width, size.height)
            (title as NSString).drawInRect(r, withAttributes: attr)
            
        }
        

        
        
    }
}



