//
//  SlideView.swift
//  SlideMenuDemo
//
//  C   reated by 马超 on 16/5/19.
//  Copyright © 2016年 qq 714080794. All rights reserved.
//

import UIKit

let menuBlackWidth: CGFloat = 50

class SlideView: UIView {

 
    var menuColor: UIColor?
    var diff: CGFloat = 50
    var animationCount: Int = 0
    var displayLink: CADisplayLink?
    var helpView0: UIView!
    var helpView1: UIView!
    var triggered: Bool = false
    
    var keyWindow = UIApplication.sharedApplication().windows.first!
    
    init(titles: [String] , buttonHeight: CGFloat , menuColor: UIColor) {
        
        super.init(frame: CGRectZero)
        
        helpView0 = UIView(frame: CGRectMake(-40,0,40,40))
        helpView0.backgroundColor = UIColor.redColor()
        keyWindow.addSubview(helpView0)
        
        helpView1 = UIView(frame: CGRectMake(-40,keyWindow.bounds.size.height / 2,40,40))
        helpView1.backgroundColor = UIColor.orangeColor()
        keyWindow.addSubview(helpView1)
        
        self.menuColor = menuColor
        frameBack()
        self.backgroundColor = UIColor.clearColor()
        
    }
    
    required init?(coder aDecoder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }

    
    //MARK: - override draw method
    override func drawRect(rect: CGRect) {
        
        let path = UIBezierPath()
        path.moveToPoint(CGPointMake(0, 0))
        path.addLineToPoint(CGPointMake(self.frame.size.width - menuBlackWidth, 0))
        path.addQuadCurveToPoint(CGPointMake(self.frame.size.width - menuBlackWidth, self.frame.size.height), controlPoint: CGPointMake(keyWindow.frame.size.width / 2 + diff, self.frame.size.height * 0.5))
        path.addLineToPoint(CGPointMake(0, self.frame.size.height))
        path.closePath()
        
        let ctx = UIGraphicsGetCurrentContext()
        CGContextAddPath(ctx, path.CGPath)
        self.menuColor?.set()
        CGContextFillPath(ctx)
    }
    
    //MARK: - action
    func trigger() {
        
        if !triggered {
            UIView.animateWithDuration(0.3) {
                
                self.frame = self.bounds
            }
            
            beforeAnimation()
            UIView.animateWithDuration(0.7, delay: 0.0, usingSpringWithDamping: 0.5, initialSpringVelocity: 0.9, options: [UIViewAnimationOptions.BeginFromCurrentState,UIViewAnimationOptions.AllowUserInteraction], animations: {
                
                self.helpView0.center = CGPointMake(self.keyWindow.center.x, self.helpView0.frame.size.height / 2)
            }) { (finished) in
                
                self.finishedAnimation()
            }
            
            beforeAnimation()
            UIView.animateWithDuration(0.7, delay: 0.0, usingSpringWithDamping: 0.8, initialSpringVelocity: 2.0, options: [UIViewAnimationOptions.BeginFromCurrentState,UIViewAnimationOptions.AllowUserInteraction], animations: {
                
                self.helpView1.center = self.keyWindow.center
            }) { (finished) in
                
                self.finishedAnimation()
            }
            
            triggered = true
        }
        else {
            
            frameBack()
            triggered = false
        }
        

    }
    
    //MARK: - private method
    func beforeAnimation() {
        
        if self.displayLink == nil {
            
            self.displayLink = CADisplayLink(target: self, selector: #selector(SlideView.displayLinkAction(_:)))
            self.displayLink!.addToRunLoop(NSRunLoop.mainRunLoop(), forMode: NSRunLoopCommonModes)
        }
        
        self.animationCount += 1
        
    }
    
    func finishedAnimation() {
        
        self.animationCount -= 1
        if self.animationCount == 0 {
            
            self.displayLink?.invalidate()
            self.displayLink = nil
        }
    }
    
    func displayLinkAction(displayLink: CADisplayLink) {
        
        let help0Labyer = helpView0.layer.presentationLayer() as! CALayer
        let help1Labyer = helpView1.layer.presentationLayer() as! CALayer
        
        let rect0 = help0Labyer.valueForKeyPath("frame")!.CGRectValue()
        let rect1 = help1Labyer.valueForKeyPath("frame")!.CGRectValue()
        
        diff = rect0.origin.x - rect1.origin.x
      
        setNeedsDisplay()
    }
    
    func frameBack() {
        
        self.frame = CGRectMake(-keyWindow.frame.size.width * 0.5 - menuBlackWidth, 0, keyWindow.frame.size.width * 0.5 + menuBlackWidth, keyWindow.frame.size.height)
        helpView0.frame = CGRectMake(-40,0,40,40)
        helpView1.frame = CGRectMake(-40,keyWindow.bounds.size.height / 2,40,40)
    }
}
